// LayerView.h : CLayerView NX̃C^[tFCX
//


#pragma once

typedef struct MiyaBasisSort
{
	int pix;
	int num;
} MiyaBasisSort;

class CLayerView : public CView
{
protected: // VÂݍ쐬܂B
	CLayerView();
	DECLARE_DYNCREATE(CLayerView)

// 
public:
	CLayerDoc* GetDocument() const;

// 
public:

// I[o[Ch
	public:
	virtual void OnDraw(CDC* pDC);  // ̃r[`悷邽߂ɃI[o[Ch܂B
virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:

// 
public:
	virtual ~CLayerView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// ꂽAbZ[W蓖Ċ֐
protected:
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnFileOpen();
	afx_msg void OnFileSaveAs();
	afx_msg void OnViewInput();
	afx_msg void OnViewValidpixel();
	afx_msg void OnViewPseudozenith();
	afx_msg void OnViewPseudoazimuth();
	afx_msg void OnViewPseudoneedle();
	afx_msg void OnViewMean();
	afx_msg void OnViewIdeal();
	afx_msg void OnViewRegion();
	afx_msg void OnViewAlbedo();
	afx_msg void OnViewZenithconstraint();
	afx_msg void OnViewAzimuthconstraint();
	afx_msg void OnViewNeedleconstraint();
	afx_msg void OnViewInside();
	afx_msg void OnViewZenithboundary();
	afx_msg void OnViewAzimuthboundary();
	afx_msg void OnViewNeedleboundary();
	afx_msg void OnViewZenithcoord();
	afx_msg void OnViewAzimuthcoord();
	afx_msg void OnViewNeedlecoord();
	afx_msg void OnViewTricolor();
	afx_msg void OnViewColor();
	afx_msg void OnUpdateViewColor(CCmdUI *pCmdUI);
	afx_msg void OnCalcInit();
	afx_msg void OnCalcSvd();
	afx_msg void OnCalcRegion();
	afx_msg void OnCalcConstraint();
	afx_msg void OnCalcBoundary();
	afx_msg void OnCalcRotation();
	afx_msg void OnCalcTricolor();
	afx_msg void OnOptionOption();
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnUpdateIndicatorMiya(CCmdUI *pCmdUI);
	virtual void OnInitialUpdate();
	void UpdateMiyaStatusbar(void);
	void CheckView(int miyamenu);
	void ReadData(CString filename, int id);
	void WriteImage(CString filename);
	void WriteData(CString filename, int filemode);
	void CreateImages(void);
	void CreateNeedleImage(int filemode);
	void CreateIdealImage();
	double pythag(double a, double b);
	void CalcSVD1(double **a, int m, int n, double w[], double **v);
	void CalcSVD0(double **a, int m, int n, double w[], double **v);
	void CalcOrthogonal(double* row0, double* row1, double* row2);
	double Median(double* x, int n, double RANGEMIN, double RANGEMAX);
	double Quarter(double* x, int n, double RANGEMIN, double RANGEMAX);
	void OrthogonalizeBasis(double** colvecs);
	double LocalEigenCost(int p, int e, double deltaval);
	double GlobalEigenCost(double** update, double scaleval);
	void CalcOptimalBasis();
	double PI;
	double EPS;
	double INF;
	int INTINF;
	int MENUVIEW;
	int COLR;
	int COLG;
	int COLB;
	int AXISX;
	int AXISY;
	int AXISZ;
	int WIDTH;
	int HEIGHT;
	int PIXELNUM;
	int IMAGEMIN;
	int IMAGEMAX;
	int MIYA_INPUT;
	int MIYA_SHADOWINIT;
	int MIYA_SPECULARINIT;
	int MIYA_VALIDPIXEL;
	int MIYA_PSEUDOZENITH;
	int MIYA_PSEUDOAZIMUTH;
	int MIYA_PSEUDONEEDLE;
	int MIYA_IDEAL;
	int MIYA_BASIS1;
	int MIYA_BASIS2;
	int MIYA_BASIS3;
	int MIYA_SHADOWOPT;
	int MIYA_SPECULAROPT;
	int MIYA_AMBIENTOPT;
	int MIYA_MEDIAN;
	int MIYA_REGION;
	int MIYA_ALBEDO;
	int MIYA_ZENITHCONSTRAINT;
	int MIYA_AZIMUTHCONSTRAINT;
	int MIYA_NEEDLECONSTRAINT;
	int MIYA_INSIDE;
	int MIYA_ZENITHBOUNDARY;
	int MIYA_AZIMUTHBOUNDARY;
	int MIYA_NEEDLEBOUNDARY;
	int MIYA_COORDZENITH;
	int MIYA_COORDAZIMUTH;
	int MIYA_COORDNEEDLE;
	int MIYA_TRICOLOR;
	int MIYA_SEP01;
	int MIYA_SEP02;
	int MIYA_SEP03;
	int MIYA_SEP04;
	int MIYA_SEP05;
	int MIYA_SEP06;
	int MIYA_SEP07;
	int MIYA_SEP08;
	int maxmenu;
	int viewmode;
	int imageview;
	bool colormode;
	int imagenum;
	bool* processdone;
	int PROCESSMAX;
	CString sFileName;
	unsigned char* screendata;
	unsigned char* inputimage;
	unsigned char*** needleimage;
	unsigned char*** idealimage;
	double*** pseudonormal;
	double*** pseudoalbedo;
	double*** normalconstraint;
	double*** albedo;
	unsigned char** inside;
	double*** normalboundary;
	double*** coordnormal;
	double** mats;
	double** matl;
	double** eigens;
	double** eigenl;
	double** conss;
	double** consl;
	double** coordl;
	bool** validpixel;
	unsigned char*** medianimage;
	bool** region;
	int REGIONINSIDE;
	int REGIONOUTSIDE;
	int REGIONBOUNDARY;
	bool* shadowinit;
	bool* specularinit;
	float* idealfloat;
	bool* shadowopt;
	bool* specularopt;
	unsigned char* tricolor;
	inline int imgarry(int i, int x, int y, int c) {return i * HEIGHT * WIDTH * 3 + y * WIDTH * 3 + x * 3 + c;}
	inline int imgarry(int x, int y, int c) {return y * WIDTH * 3 + x * 3 + c;}
	inline int pixarry(int i, int x, int y) {return i * WIDTH * HEIGHT + y * WIDTH + x;}
	inline int pixarry(int x, int y) {return y * WIDTH + x;}
	inline double SQR(double x) {return x * x;}
	inline double SIGN(double a, double b) {return (b >= 0.0) ? fabs(a) : -fabs(a);}
	inline double FMAX(double a, double b) {return (a > b) ? a : b;}
	inline int IMIN(int a, int b) {return (a < b) ? a : b;}
	inline double NORM(double x, double y, double z) {return sqrt(SQR(x) + SQR(y) + SQR(z));}
	inline double DOTPRODUCT(double ax, double ay, double az, double bx, double by, double bz) {return ax * bx + ay * by + az * bz;}
	afx_msg void OnViewBasis1();
	afx_msg void OnViewBasis2();
	afx_msg void OnViewBasis3();
	afx_msg void OnCalcOptimize();
	afx_msg void OnViewShadowinit();
	afx_msg void OnViewSpecularinit();
	afx_msg void OnViewShadowopt();
	afx_msg void OnViewSpecularopt();
	typedef Graph<float,float,float> GraphType;
	GraphType* graph;
	void CalcOptimalShadow();
	void CalcOptimalSpecular();
	inline unsigned char inputvalue(int i, int x, int y) {return (unsigned char)(((int)inputimage[imgarry(i,x,y,COLR)] + 2 * (int)inputimage[imgarry(i,x,y,COLG)] + (int)inputimage[imgarry(i,x,y,COLB)]) / 4);}
};

#ifndef _DEBUG  // LayerView.cpp ̃fobO o[W
inline CLayerDoc* CLayerView::GetDocument() const
   { return reinterpret_cast<CLayerDoc*>(m_pDocument); }
#endif

